const TblMapaListagem = require("../models/TblMapasListagem");

const getAllListagemMapas = async (queryParams = {}) => {
  return TblMapaListagem.findAll({
    where: queryParams,
  });
};

const getListagemMapaById = async (id, queryParams = {}) => {
  const whereCondition = { intId: id, ...queryParams };

  return TblMapaListagem.findOne({
    where: whereCondition,
  });
};



const createListagemMapa = async (mapaListagemData) => {
  return TblMapaListagem.create(mapaListagemData);
};

const updateListagemMapa = async (id, mapaListagemData) => {
  const mapaListagem = await TblMapaListagem.findByPk(id);
  if (!mapaListagem) {
    throw new Error("MapaListagem not found");
  }
  return mapaListagem.update(mapaListagemData);
};

const deleteListagemMapa = async (id) => {
  // Assuming TblMapaListagem is your Sequelize model
  const result = await TblMapaListagem.update(
    { bitEliminado: true },
    { where: { intId: id } }
  );

  // The 'result' object contains information about the operation
  const affectedRows = result[0];

  if (affectedRows === 0) {
    throw new Error("MapaListagem not found");
  }

  // You might want to return additional information if needed
  return { success: true, message: "MapaListagem soft deleted successfully" };
};

module.exports = {
  getAllListagemMapas,
  getListagemMapaById,
  createListagemMapa,
  updateListagemMapa,
  deleteListagemMapa,
};
